<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <base-card>
    <div v-if="isLoading">
      <base-spinner></base-spinner>
    </div>
    <div v-else-if="!isLoading && reports.length > 0">
      <ul>
        <report-item
          v-for="report in reports.length"
          :key="reports[report - 1]['uuId']"
          :id="reports[report - 1]['id']"
          :topic="reports[report - 1]['topic']"
          :comment="reports[report - 1]['comment']"
        >
        </report-item>
      </ul>
      <div class="button">
        <base-button mode="outline" link to="/form"
          >Dodaj zgłoszenie
        </base-button>
      </div>
      <img :src="`data:image/png;base64,${image}`" width="400" height="200" />
    </div>
  </base-card>
</template>

<script setup>
import ReportItem from "@/components/ReportItem.vue";
import { ref, onMounted } from "vue";
import { useStore } from "vuex";

const isLoading = ref(false);
const error = ref(null);
const reports = ref([]);
const image = ref("");

const store = useStore();

async function loadReports() {
  isLoading.value = true;
  try {
    await store.dispatch("loadReports");
  } catch (er) {
    error.value = er.message || "Nie udało się załadować zgłoszeń.";
  }
  isLoading.value = false;
}

function handleError() {
  error.value = null;
}

onMounted(async function () {
  await loadReports();
  reports.value = store.getters.reports;
  image.value = store.getters.image;
});
</script>

<style scoped>
.button {
  text-align: center;
}
</style>
